/*
*    recopa.c
*    ReCoPa verze 0.5 cz
*    Program pro prevod textovych souboru mezi ruznymi kodovymi strankami.
*    9.5.2002  Jaroslav Beran (berk@volny.cz) http://www.volny.cz/berk
*    Licence GNU/GPL2
*    posledni zmena 12.5.2002 - 01
*/

#define VERSION "ReCoPa verze 0.5 cz"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rcfiles.h"

#define RCFILE "recopa.rc"

int main(int argc, char *argv[])
{
  char **sekce, *nazev, *pom;
  int n, pozice, pocet, znak;
  unsigned int sp, max;
  int c, table[2][256];
  FILE *fr, *fpom;

  if(argc !=4){
	printf("%s - program pro prevod textovych soub. mezi ruznym kodovanim.\n", VERSION);
    printf("(c)2002 Jaroslav Beran - berk@volny.cz http://www.volny.cz/berk\n");
    printf("Licence GNU/GPL2 (http://www.gnu.cz)\n\n");

	puts("Pouziti:");
	puts("recopa input_code_page output_code_page input_file\n");
	puts("Dostupne kodove stranky:");
    if((sekce=GetSections(&pocet, RCFILE))!=NULL){
	  max=0;
	  for(n=0; n<pocet; n++){
        if(max<strlen(*(sekce+n)))
		  max=strlen(*(sekce+n));
	  }
      for(n=0; n<pocet; n++){
		fputs(*(sekce+n), stdout);
		for(sp=0; sp<(max-strlen(*(sekce+n))); sp++)
		  putchar(' ');
		nazev=GetItem(RCFILE, *(sekce+n), "tname");
		printf(" - %s\n", nazev);
		free((void *) nazev);
	  }
	  for(n=0; n<pocet; n++)
		free((void *) *(sekce+n));
	  free((void *) sekce);
	}
	puts("\nPriklad:");
	puts("recopa 1250 il2 text.txt");
	return(0);
  }

  /* nacteni stringu z rc souboru */
  if((pom=GetItem(RCFILE, argv[1], "table"))==NULL){
	printf("Tabulka %s neexistuje\n", argv[1]);
	return(1);
  }

  /* nacteni stringu do pole */
  pocet=0;
  n=0;
  while((pocet < 256) && (sscanf(pom, "%2x", &table[0][pocet]) != EOF)){
    while((pom[n]!=',') && (pom[n]!='\0'))
	  pom[n++]=' ';
	if(pom[n]==',')
	  pom[n]=' ';
	table[1][pocet]=pocet;
	pocet++;
  }

  free((void *) pom);

  /* nacteni stringu z rc souboru */
  if((pom=GetItem(RCFILE, argv[2], "table"))==NULL){
	printf("Tabulka %s neexistuje\n", argv[2]);
	return(1);
  }

  /* nacteni stringu do pole */
  pocet=0;
  n=0;
  while((pocet < 256) && (sscanf(pom, "%2x", &c) != EOF)){
    while((pom[n]!=',') && (pom[n]!='\0'))
	  pom[n++]=' ';
	if(pom[n]==',')
	  pom[n]=' ';
	/* dolni ascii (do 126) neprepisovat! */
    for(pozice=127; pozice<256; pozice++){
	  if(c == table[0][pozice]) {
		table[1][pozice]=pocet;
		break;
	  }
	}
	pocet++;
  }

  free((void *) pom);

  /* zpracovani souboru */
  if((fr=fopen(argv[3], "r"))==NULL){
	printf("Soubor %s se neda otevrit pro cteni\n", argv[3]);
	return(1);
  }
  while((znak=getc(fr))!=EOF)
	putchar(table[1][znak]);
  fclose(fr);

  return(0);
}
